function Timeout(timeout) { // inner class Timeout
    var startTime = new Date().getTime();

    this.timedOut = function() {
	var now = new Date().getTime();

	var lapsed = now - startTime;

	return lapsed > timeout;
    }
}

function AsyncFunction(name, fun, timeout, tick) {
    this.timeout = parseInt(timeout || -1);
    this.name = name;
    this.fun = fun;
    this.tick = parseInt(tick || 100);
    
}

AsyncFunction.prototype.execute = function() {
    if (this._timeout) {
	if (this._timeout.timedOut()) {
	    var e = new Error(this.name + ": timeout after " + this.timeout + " miliseconds");
	    e.id = this.name + "_" + "TimeoutError";
	    e.args = [this.timeout];
	    throw e;
	}
    } else if (this.timeout > 0) {
	this._timeout = new Timeout(this.timeout);
    }

    try {
	return this.fun();
    } catch (e) {
	Components.utils.reportError(e);
	return false;
    }
}

    
function DefferedFunctions(funcs) {
    this.funcs = funcs || [];
    this.tick = 100;
}

DefferedFunctions.prototype.onfinish = function() {
    trace("(yagi):" + "DefferedFunctions:onfinish");
}

DefferedFunctions.prototype.onerror = function(e) {
    Components.utils.reportError("DefferedFunctions:onerror: " + e);
}

DefferedFunctions.prototype.doFun = function(fun, self) {

    try {
	var res = fun.execute();

	if (typeof res != "boolean") {
	    throw new Error("programming error: your deffered function must return a boolean: true if succeeded, false if needs to run again next loop");
	}

	if (!res) {	// need to run this one again
	    setTimeout(self.doFun, fun.tick, fun, self);
	} else {
	    self.doNext();
	} 
    } catch (e) {
	var name = (fun.name || "doFun: ");
	trace("(yagi): DefferedFunctions.doNext: error: " + name + " " + e);
	self.onerror(name + " " + e);
    }
}
	    
DefferedFunctions.prototype.doNext  =  function() {
    var next_func = this.funcs.shift();
    
    if (next_func) {
	this.doFun(next_func, this);
    } else {
	try {
	    this.onfinish();
	} catch (e) {
	    trace("(yagi): DefferedFunctions.doNext: error: onfinish: " + e);
	    this.onerror("onfinish " + e);
	}
    }
}

DefferedFunctions.prototype.add = function(fun) {
    this.funcs.push(fun);
}

DefferedFunctions.prototype.execute = function() {
    this.doNext();
}

