
function ClassLoader(java, classLoaderPath) {
  this.policy = null;
  this.java = java;

  var classLoaderURL = new java.net.URL(classLoaderPath);

  var bootstrapClassLoader = java.net.URLClassLoader.newInstance(toUrlArray([classLoaderPath]));
  var policyClass = java.lang.Class.forName(
					    "org.nargila.mozilla.URLSetPolicy",
					    true,
					    bootstrapClassLoader);
        
  // then we inject this class into the security policy of the JVM security manager
  // to have permission to load our own classloader from the classloading jar.
  var policy = policyClass.newInstance();
  policy.setOuterPolicy(java.security.Policy.getPolicy());
  java.security.Policy.setPolicy(policy);

  policy.addPermission(new java.security.AllPermission());
    
  policy.addURL(classLoaderURL);

  this.policy = policy;
  this.java = java;


  function toUrlArray(a) {
      var urlArray = java.lang.reflect.Array.newInstance(java.net.URL, a.length);

      for (var i = 0; i < a.length; i++) {
	  var url = a[i];
	  java.lang.reflect.Array.set(
				      urlArray, 
				      i, 
				      (typeof url == "string") ? new java.net.URL(url) : url
				      );
      }

      return urlArray;
  }
  
}

ClassLoader.prototype = {
  addURL: function(url) {
    this.policy.addURL(new this.java.net.URL(url));
  },

  addURLs: function(urls) {
    for (var i in urls) {
      this.addURL(urls[i]);
    }
  },
  getClass: function(name) {
    var classLoader = new this.java.net.URLClassLoader(this.policy.getUrls());

    this.java.lang.Thread.currentThread().setContextClassLoader(classLoader);

    var javaClass = this.java.lang.Class.forName(name, true, classLoader);

    return javaClass;
  },
  newInstance: function(name, args) {
    var classLoader = new this.java.net.URLClassLoader(this.policy.getUrls());

    this.java.lang.Thread.currentThread().setContextClassLoader(classLoader);

    var javaClass = this.getClass(name);

    var instance = args ? javaClass.newInstance(args) : javaClass.newInstance();
    return instance;
  }
};
 

