const LP_LPNS = "http://www.yagitalk.org/mozext/link.preference.to.xul.element";



function LP_xpath(aXpath, scope)
{
  var foundNodes = new Array();
  var res;
  var nsResolver = function(prefix) {
      var ns = {    'lp' : 'http://www.yagitalk.org/mozext/link.preference.to.xul.element'  };
      return ns[prefix] || null;
  };

  var result = document.evaluate(aXpath, scope || document, nsResolver, 0, null);

  while ((res = result.iterateNext())) {
      foundNodes.push(res);
  }
  return foundNodes;
}

function bindPreferenceElements() {
    var arr = LP_xpath("//*[@lp:pref]");

    arr.forEach(function(e) {
	    try {
		linkpreference(e);
	    } catch (e) {
		Components.utils.reportError(e);
	    }
	});
}

function linkpreference(element) {
    var preference = element.getAttributeNS(LP_LPNS, "pref");
    var branch = element.getAttributeNS(LP_LPNS, "branch");
    var linkjava = element.getAttributeNS(LP_LPNS, "java");
    var attr = element.getAttributeNS(LP_LPNS, "attr") || "value";

    var prefs = YAGI_getPrefBranch(branch);

    var type = element.getAttribute("type");

    var onPrefChangeFun;
    var onAttrChangeFun;

    switch (type) {
    case "checkbox":
    case "radio":
	onPrefChangeFun = function(value) {
	    if (value == element.getAttribute(attr)) {
		element.setAttribute("checked", "true");
	    }
	};
	onAttrChangeFun = function(evt) {
	    if (element.getAttribute("checked") == "true") {
		YAGI_setPref(branch, preference, element.getAttribute(attr), true);
	    }
	};
	break;
    default:
	onPrefChangeFun = function(value) {
	    dump("(yagi):" + "lp:" + element.id + ":onPrefChangeFun(" + preference + "=" + value + "\n");
	    element.setAttribute(attr, value);
	};

	onAttrChangeFun = function(evt) {
	    dump("(yagi):" + "lp:" + element.id + ":onAttrChangeFun(" + preference + "=" + evt.newValue + "\n");
	    if (evt.attrName == attr) {
		YAGI_setPref(branch, preference, evt.newValue, true);
	    }
	};

	break;
    }


    function attrHandler(evt) {
	var fireevent = false;

	switch (type) {
	case "radio":
	case "checkbox":
	    fireevent = evt.attrName == "checked";
	    break;
	default:
	    fireevent = evt.attrName == attr;
	    break;
	}

	if (fireevent && evt.prevValue != evt.newValue) {
	    onAttrChangeFun(evt);
	    
	    if (false && linkjava) {
		var val = element.getAttribute(attr);
		dump("(yagi):" + "java.lang.System.setProperty(\"" + preference + "\"," + "\""+ val + "\")\n");
		java.lang.System.setProperty(preference, val);
	    }
 	}
    }

    function propHandler(value) {
	dump("(yagi):" + "linkpref: change: " + preference + "=" + value + "\n");
	onPrefChangeFun(value);

	if (linkjava) {
	    dump("(yagi):" + "linkpref: java: " + preference + "=" + value + "\n");
	    java.lang.System.setProperty(preference, value);
	}
    }

    propHandler(YAGI_getPref(branch, preference));
    
    element.addEventListener("DOMAttrModified", attrHandler, false);
    
    YAGI_linkPref(branch, preference, function(pref, value) {
	    element.removeEventListener("DOMAttrModified", attrHandler, false);
	    propHandler(YAGI_getPref(branch, preference));
	    element.addEventListener("DOMAttrModified", attrHandler, false);
	}, false);    
}

function YAGI_linkPrefObject(obj, prop, pref, linkjava, create) {

    var [dummy, branch, preference] = pref.match(/^([^\.]+\.)(.+)$/);

    function objWatchHandler(p, oldv, newv) {
	if (oldv != newv) {
	    dump("(yagi):" + "YAGI_linkPrefObject: info: copying to pref: " + pref + "=" + newv + " (obj." + prop + ")");
	    YAGI_setPref(branch, preference, newv, true);	    
 	}

	return newv;
    }

    function prefHandler(pref, value) {
	dump("(yagi):" + "YAGI_linkPrefObject: info: copying to object: obj." + prop + "=" + value + " (" + pref + ")");

	obj[prop] = value;

	if (linkjava) {
	    java.lang.System.setProperty(preference, value);
	}
    }
    
    if (create) { // create if not exist
	try {
	    var val = YAGI_getPref(branch, preference);
	} catch (e) { // no such preference
	    YAGI_setPref(branch, preference, obj[prop], true);
	}
    }

    YAGI_linkPref(branch, preference, prefHandler);
    
    obj.watch(prop, objWatchHandler);
}
