const nsIWindowsRegKey = Components.interfaces.nsIWindowsRegKey;

function _readRegistryValue(wrk, value)
{
  switch (wrk.getValueType(value)) {
    case wrk.TYPE_STRING:
      return wrk.readStringValue(value);
    case wrk.TYPE_BINARY:
      return wrk.readBinaryValue(value);
    case wrk.TYPE_INT:
      return wrk.readIntValue(value);
    case wrk.TYPE_INT64:
      return wrk.readInt64Value(value);
  }
  // unknown type
  return null;
}

function _getRegistry() {
  var wrk = Components.classes["@mozilla.org/windows-registry-key;1"]
    .createInstance(nsIWindowsRegKey);
  
  return wrk;
}

function getKeyValue(root, key, value) {
  wrk = _getRegistry();

  var retval = null;

  try {
    wrk.open(root, key, wrk.ACCESS_READ);
    retval = _readRegistryValue(wrk, value);
  } catch (e) {
  } finally {
    wrk.close();
  }
  
  return retval;
}

function setKeyValue(root, key, name, value, type) {
  wrk = _getRegistry();

  try {
    wrk.create(root, key, wrk.ACCESS_WRITE);

    switch (type) {
    case wrk.TYPE_STRING:
      wrk.writeStringValue(name, value);
      break;
    case wrk.TYPE_BINARY:
      throw "not implemented";
      break;
    case wrk.TYPE_INT:
      wrk.writeIntValue(name, value);
      break;
    case wrk.TYPE_INT64:
      wrk.writeInt64Value(name, value);
      break;
    }
  } catch (e) {
    return false;
  } finally {
    wrk.close();
  }

  return true;
}
