
var gLocalFonts = null;
var gStringBundle = null;
var gUserHomeDir = null;
var kFixedFontFaceMenuItems = 1;

String.prototype.trim = function() {
  return this.replace(/^\s*|\s*$/g, "")
}

function sleep(ms) {
  var nsIThread = Components.interfaces.nsIThread;

  var thread = Components.classes["@mozilla.org/thread;1"].createInstance(nsIThread);

  thread.currentThread.sleep(ms);
}








function fileWrite(file, data) {
    makeDir(file.parent);	// recursive create parent path

    var ofs = FileWriter(file);

    ofs.write(data, data.length);
    ofs.close();
}




function trace(msg) {

    if (tracingEnabled) {

	dump(msg + "\n");

	Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService).logStringMessage(msg);
    }
}


function fixPath(unixPath) {
  unixPath = unixPath.replace(/\\/g, '/'); // replace windows '\' with universal '/' - windows XP/2K will not complain
  return unixPath;
}

function LocalFile(path) {
  const myFile = new Components.Constructor("@mozilla.org/file/local;1", 
                                            "nsILocalFile",
                                            "initWithPath");
  return new myFile(path);
}

function FileWriter(f) {
  var ofs = Components.classes["@mozilla.org/network/file-output-stream;1"].
    createInstance(Components.interfaces.nsIFileOutputStream);

  ofs.init(f, 0x02 | 0x08 | 0x40 | 0x20, -1, 0);


  return ofs;
}

function evalFile(file, scope) {
  var data = readFile(file);

  if (scope) {
    return scope.eval(data);
  }

  return eval(data);
}

function inputStream(file) {

  var ifs  = Components.classes["@mozilla.org/network/file-input-stream;1"].
    createInstance(Components.interfaces.nsIFileInputStream);

  ifs.init(file, 0x01, -1, 0);

  return ifs;
}

function readFile(file) {
    var ifs = inputStream(file);

    return readStream(ifs);
}
	
function readStream(ifs) {

  var sis = Components.classes["@mozilla.org/scriptableinputstream;1"].
    createInstance(Components.interfaces.nsIScriptableInputStream);
  sis.init(ifs);
      
  var data = sis.read(sis.available());

  sis.close();

  return data;
}
	

function makeEventQueueProxy(queue, obj, iid) {

  if (!obj.QueryInterface) {
    obj.QueryInterface = function(_iid) {
      if (_iid.equals(iid) || 
	  _iid.equals(Components.interfaces.nsISupports)) {
	return this;
      }
      
      throw Components.results.NS_ERROR_NO_INTERFACE;
    };
  }
  var proxyCID = "@mozilla.org/xpcomproxy;1";
  var nsIProxyObjectManager = Components.interfaces.nsIProxyObjectManager;

  var proxyManager = Components.classes[proxyCID].createInstance(nsIProxyObjectManager);

  var proxy = 
    proxyManager.getProxyForObject(queue, iid, obj, proxyManager.FORCE_PROXY_CREATION|proxyManager.INVOKE_ASYNC);
  
  return proxy;
}


function getHomeDir() {
  if (!gUserHomeDir) {
    const nsIDirectoryServiceProvider_CONTRACTID = "@mozilla.org/file/directory_service;1";
    const nsIDirectoryServiceProvider = Components.interfaces.nsIDirectoryServiceProvider;
    var dirServiceProvider = Components.classes[nsIDirectoryServiceProvider_CONTRACTID]
      .getService(nsIDirectoryServiceProvider);
    var persistent = new Object();

    gUserHomeDir = dirServiceProvider.getFile("Home", persistent);
  }

  return gUserHomeDir.path;
}

function getDesktopDir() {
    const nsIDirectoryServiceProvider_CONTRACTID = "@mozilla.org/file/directory_service;1";
    const nsIDirectoryServiceProvider = Components.interfaces.nsIDirectoryServiceProvider;
    var dirServiceProvider = Components.classes[nsIDirectoryServiceProvider_CONTRACTID]
	.getService(nsIDirectoryServiceProvider);
    var persistent = new Object();
    
    var res;

    try {
	res = dirServiceProvider.getFile("DeskP", persistent).path;
    } catch (e) {
	res = getHomeDir();
    }
	    
    
    return res;
}

function fileBrowse(mode, defaultDir, suggestName, filters)
{
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);

	if(mode=="open")
		fp.init(window, localize('Open'), nsIFilePicker.modeOpen);
	else if(mode=="save") {
	  fp.init(window, localize('SaveAs'), nsIFilePicker.modeSave);
	  if (suggestName) fp.defaultString = suggestName;
	} else if(mode=="folder")
		fp.init(window, localize('SaveFolder'), nsIFilePicker.modeGetFolder);

	for (var i in filters) {
	  var f = filters[i];
	  fp.appendFilter(f[0], f[1]);
	}

	fp.appendFilters( nsIFilePicker.filterAll);

	if(defaultDir && defaultDir.exists()) {
	  fp.displayDirectory = defaultDir;
	} else {
	  getHomeDir();
	  fp.displayDirectory = gUserHomeDir;
	}

	var res=fp.show();
	if (res==nsIFilePicker.returnOK || nsIFilePicker.returnReplace ){
		var thefile=fp.file;
		return thefile;
	}else{
		return false;
	}
}

function fillFileName(mode, suggestName, filters, elementID) {
  var file = fileBrowse(mode, null, suggestName, filters);

  if (file) {
    var err = null;
  
    switch (mode) {
    case "open":
      if (!file.isReadable()) {
	err = "no read permission";
      }
      break;
    case "save":
      if (!file.parent.isWritable()) {
	err = "no write permission";
      }
      break;
    }

    if (err) {
      alert(file.path + ": " + err);
    } else {
      document.getElementById(elementID).value = file.path;
    }
  }
}


function goToggleToolbar( id, elementID )
{
  var toolbar = document.getElementById(id);
  var element = document.getElementById(elementID);
  if (toolbar)
  {
    var isHidden = toolbar.hidden;
    toolbar.hidden = !isHidden;
    document.persist(id, 'hidden');
    if (element) {
      element.setAttribute("checked", isHidden ? "true" : "false");
      document.persist(elementID, 'checked');
    }
  }
}

function getFolderPath()
{
	var newfile = fileBrowse("folder");
	return FileIO.path(newfile);
}

function getFilePath()
{
	var newfile = fileBrowse("open");
	return FileIO.path(newfile);
}

function AlertWithTitle(title, message, parentWindow)
{
  if (!parentWindow)
    parentWindow = window;

  var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService();
  promptService = promptService.QueryInterface(Components.interfaces.nsIPromptService);

  if (promptService)
  {
    if (!title)
      title = GetString("Alert");

    // "window" is the calling dialog window
    promptService.alert(parentWindow, title, message);
  }
}

// Optional: Caller may supply text to substitue for "Ok" and/or "Cancel"
function ConfirmWithTitle(title, message, okButtonText, cancelButtonText)
{
  var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService();
  promptService = promptService.QueryInterface(Components.interfaces.nsIPromptService);

  if (promptService)
  {
    var okFlag = okButtonText ? promptService.BUTTON_TITLE_IS_STRING : promptService.BUTTON_TITLE_OK;
    var cancelFlag = cancelButtonText ? promptService.BUTTON_TITLE_IS_STRING : promptService.BUTTON_TITLE_CANCEL;

    return promptService.confirmEx(window, title, message,
                            (okFlag * promptService.BUTTON_POS_0) +
                            (cancelFlag * promptService.BUTTON_POS_1),
                            okButtonText, cancelButtonText, null, null, {value:0}) == 0;
  }
  return false;
}

function ConfirmAdvanced(dialogTitle, dialogMsg, okButtonText, cancelButtonText, extraButtonText)
{
  var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService();
  promptService = promptService.QueryInterface(Components.interfaces.nsIPromptService);
  var result = 1;
  if (promptService)
  {
    var okFlag = okButtonText ? promptService.BUTTON_TITLE_IS_STRING : promptService.BUTTON_TITLE_SAVE;
    var cancelFlag = cancelButtonText ? promptService.BUTTON_TITLE_IS_STRING : promptService.BUTTON_TITLE_CANCEL;
    var extraFlag = extraButtonText ? promptService.BUTTON_TITLE_IS_STRING : promptService.BUTTON_TITLE_DONT_SAVE;

    result = promptService.confirmEx(window, dialogTitle, dialogMsg,
                            (okFlag * promptService.BUTTON_POS_0) +
                            (cancelFlag * promptService.BUTTON_POS_1)+
                            (extraFlag * promptService.BUTTON_POS_2),
                            okButtonText, cancelButtonText, extraButtonText, null, {value:0});
  }
  return result;
}
function infoWin(img, title, message)
{
    const params = Components.classes["@mozilla.org/embedcomp/dialogparam;1"]
                             .createInstance(Components.interfaces.nsIDialogParamBlock);
    params.SetNumberStrings(3);
    params.SetString(0, img);
    params.SetString(1, title);
    params.SetString(2, message);
    const ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
                         .getService(Components.interfaces.nsIWindowWatcher);
    return ww.openWindow(null, "chrome://ssspeak/content/dialogs/info.xul", "info", "chrome,all,centerscreen,alwaysRaised,dialog,modal=no,resizable=no", params);

}

if(typeof openHelp=='undefined'){
	function openHelp() {
		return openBrowserURL('http://ssspeak.com/support');
	}
}

function localize(name)
{
  if (!gStringBundle)
  {
    try {
      var strBundleService =
          Components.classes["@mozilla.org/intl/stringbundle;1"].getService(); 
      strBundleService = 
          strBundleService.QueryInterface(Components.interfaces.nsIStringBundleService);

      gStringBundle = strBundleService.createBundle("chrome://ssspeak/locale/ssspeak.properties"); 

    } catch (ex) {}
  }
  if (gStringBundle)
  {
    try {
      return gStringBundle.GetStringFromName(name);
    } catch (e) {}
  }
  return null;
}

function SupportsArray()
{
	return Components.classes['@mozilla.org/supports-array;1']
							.createInstance(Components.interfaces.nsISupportsArray);
}

function IsWhitespace(string)
{
  return /^\s/.test(string);
}

function GetSelectionAsText()
{
  try {
    return GetCurrentEditor().outputToString("text/plain", 1); // OutputSelectionOnly
  } catch (e) {}

  return "";
}
function stripChars(string) {
    string = string.replace(/\\/g,"\\\\");
    string = string.replace(/\(/g,"\\(");
    string = string.replace(/\)/g,"\\)");
    string = string.replace(/\$/g,"\\$");
    string = string.replace(/\^/g,"\\^");
    string = string.replace(/\[/g,"\\[");
    string = string.replace(/\]/g,"\\]");
    string = string.replace(/\{/g,"\\{");
    string = string.replace(/\}/g,"\\}");
    string = string.replace(/\+/g,"\\+");
    string = string.replace(/\?/g,"\\?");
    string = string.replace(/\./g,"\\.");
    string = string.replace(/\|/g,"\\|");

    return string;
}
function TextIsURI(selectedText)
{
  return selectedText && /^http:\/\/|^https:\/\/|^file:\/\/|\
    ^ftp:\/\/|^about:|^mailto:|^news:|^snews:|^telnet:|^ldap:|\
    ^ldaps:|^gopher:|^finger:|^javascript:/i.test(selectedText);
}

function openBrowserURL(url)
{
	var b = getContentBrowser();
	if(b){
		gotoLink(url);
	}else{
		try{
			open(url);
		}catch(ex){
			var winw = Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
                         .getService(Components.interfaces.nsIWindowWatcher);
			winw.openWindow(null, url, "_blank", "chrome,all,dialog=no,width=500,height=400,sizemode=maximized",
				Components.classes["@mozilla.org/embedcomp/dialogparam;1"]
                             .createInstance(Components.interfaces.nsIDialogParamBlock));
			return true;
		}
	}
	return true;
}
function launchPreview(targetpath, url)
{
	var targetFile = FileIO.open(targetpath);

	var process = Components.classes['@mozilla.org/process/util;1'].getService(Components.interfaces.nsIProcess);
	process.init(targetFile);
	var arguments= [] ;

	arguments.push(url);

	process.run(false, arguments, arguments.length,{});
}

function goToggleElement( id, elementID )
{
  var toolbar = document.getElementById( id );
  var element = document.getElementById( elementID );
  if ( toolbar )
  {
    var attribValue = toolbar.getAttribute("hidden") ;

    if ( attribValue == "true" )
    {
      toolbar.setAttribute("hidden", "false" );
      if ( element )
        element.setAttribute("checked","true");
    }
    else
    {
      toolbar.setAttribute("hidden", true );
      if ( element )
        element.setAttribute("checked","false");
    }
    document.persist(id, 'hidden');
    document.persist(elementID, 'checked');
  }
}

function colID(tree, id){

}

function initLocalFontFaceMenu(menuPopup)
{
  if (!gLocalFonts)
  {
    // Build list of all local fonts once per editor
    try 
    {
      var enumerator = Components.classes["@mozilla.org/gfx/fontenumerator;1"]
                                 .getService(Components.interfaces.nsIFontEnumerator);
      var localFontCount = { value: 0 }
      gLocalFonts = enumerator.EnumerateAllFonts(localFontCount);
    }
    catch(e) { }
  }
  
  var useRadioMenuitems = (menuPopup.parentNode.localName == "menu"); // don't do this for menulists  
  if (menuPopup.childNodes.length == kFixedFontFaceMenuItems) 
  {
    if (gLocalFonts.length == 0) {
      menuPopup.childNodes[kFixedFontFaceMenuItems - 1].hidden = true;
    }
    for (var i = 0; i < gLocalFonts.length; ++i)
    {
      if (gLocalFonts[i] != "")
      {
        var itemNode = document.createElementNS(XULNS, "menuitem");
        itemNode.setAttribute("label", gLocalFonts[i]);
        itemNode.setAttribute("value", gLocalFonts[i]);
        if (useRadioMenuitems) {
          //itemNode.setAttribute("type", "radio");
          itemNode.setAttribute("name", "2");
          itemNode.setAttribute("observes", "cmd_formatBlock");
        }
        menuPopup.appendChild(itemNode);
      }
    }
  }
}
function osPath(path)
{
	path = unescape(path);
	if(gOS==gWin)
		return path.replace('file:///', '').replace('|',':').replace(/\//g, '\\');
	else
		return path.replace('file://', '');
};

function getExt(path) {
	var rv='';
	try {
		var dotIndex  = path.lastIndexOf('.');
		rv=(dotIndex >= 0) ? path.substring(dotIndex+1) : "";
		return rv;
	}catch(e) {
		return '';
	}
}

function getBrowserPath(path) {
	try {
		return 'file:///' + path.replace(/\\/g, '\/')
			.replace(/^\s*\/?/, '').replace(/\ /g, '%20');
	}
	catch(e) {
		return false;
	}
}


function YAGI_addNotification(doc, title, name, img, priority, buttons) {
    
    var tabBrowser = document.getElementById("content");
    var browser = tabBrowser.getBrowserForDocument(doc || content.document);
    var notificationBox = tabBrowser.getNotificationBox(browser);

    var priority_id;

    switch (priority) {
    case "warning":
	priority_id = notificationBox.PRIORITY_WARNING_MEDIUM;
	break;
    case "info":
	priority_id = notificationBox.PRIORITY_INFO_MEDIUM;
	break;
    case "error":
	priority_id = notificationBox.PRIORITY_CRITICAL_MEDIUM;
	break;
    case "blocking":
	priority_id = notificationBox.PRIORITY_CRITICAL_BLOCK;
	break;
    default:
	throw Error("Internal error: YAGI_addNotification: HDIGH!");
    }

    var notification = notificationBox.appendNotification(title, name, img, priority_id, buttons);
}

function gotoLink(URL) {
	var brw = getContentBrowser();
	if (true) {
		var newtab = brw.addTab(URL);
		brw.selectedTab = newtab;
		return newtab;
	} else {
		return brw.loadURI(URL);
	}
}

function getContentBrowser() {
	var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
	var topWindowOfType = windowManager.getMostRecentWindow("navigator:browser");
	if (topWindowOfType) {
		return topWindowOfType.document.getElementById('content');
	}
	return null;
}


//-----------------------------------------------------------------------------------
function alertObject(obj)
{
  var names = "";
  for (var i in obj)
  {
    if (i == "value")
      names += i + ": " + obj.value + "\n";
    else if (i == "id")
      names += i + ": " + obj.id + "\n";
    else
      names += i +"\t=\t"+String(obj[i])+ "\n";
  }
  
  alert("-----" + obj + "------\n"+names + "-----------\n");
}

//-----------------------------------------------------------------------------------
function PrintObject(obj)
{
  dump("(yagi):" + "-----" + obj + "------\n");
  var names = "";
  for (var i in obj)
  {
    if (i == "value")
      names += i + ": " + obj.value + "\n";
    else if (i == "id")
      names += i + ": " + obj.id + "\n";
    else
      names += i + "\n";
  }
  
  dump("(yagi):" + names + "-----------\n");
}

//-----------------------------------------------------------------------------------
function PrintNodeID(id)
{
  PrintObject(document.getElementById(id));
}


String.prototype.trim = function(){
	return this.replace(/(^\s+)|(\s+$)/g, '');
};


String.prototype.replaceWhitespace = function(replaceVal)
{
	return this.replace(/(^\s+)|(\s+$)/g,'').replace(/\s+/g,replaceVal)
}

String.prototype.convertToCDATA = function()
{
  return this.replace(/\s+/g,"_").replace(/[^a-zA-Z0-9_\.\-\:\u0080-\uFFFF]+/g,'');
}

/*
Array.prototype.removeAt=function(i){
	this.splice(i,1);
};
Array.prototype.sortn=function(i){
	this.sort(function(a,b){return a-b;});
};
*/

String.prototype.capitalize=function()
{
	return this.charAt(0).toUpperCase()+this.substr(1);
};

function toggleCommandSet(id, enable) {
  var commands = document.getElementById(id).childNodes;

  for (var i = 0; i < commands.length; ++i) {
    var command = commands[i];
    
    if (enable) {
      command.removeAttribute("disabled");
    } else {
      command.setAttribute("disabled", "true");
    }
  }
  return;
}

/*
 *  Get the file path to the installation directory of this 
 *  extension.
 */

if (!dump) {
  function dump(txt) {
  }
 }

function getExtensionPath(extensionName, returnAsLocalPath) {
  var chromeRegistry = 
    Components.classes["@mozilla.org/chrome/chrome-registry;1"].getService(Components.interfaces.nsIChromeRegistry);

  var uri = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);

  uri.spec = "chrome://" + extensionName + "/content/";

  var path = chromeRegistry.convertChromeURL(uri);

  var retval;

  if (returnAsLocalPath) {
    var file = path.QueryInterface(Components.interfaces.nsIFileURL).file;

    while (!file.path.match(/chrome$/)) {
      file = file.parent;
    }

    retval = file.parent.path;
  } else {
    if (typeof(path) == "object") {
      path = path.spec;
    }

    path = path.substring(0, path.indexOf("/chrome/") + 1);
    
    var arr = path.split("jar:"); // just in case the chrome contents is packed into a jar archive

    retval = arr.length == 2 ?  arr[1] : arr[0];
  }

  return retval
}

function buildPath(rootPath, pathParts) {
    //trace("rootPath=" + rootPath + ", pathParts=" + pathParts + "\n");

    pathParts = pathParts || [];
    rootPath = rootPath || pathParts.shift();
    
    
    if (!rootPath) {
	throw new Error("internal error: buildPath(): rootPath is null");
    }

    var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);

    if (rootPath instanceof Components.interfaces.nsILocalFile) {
	file.initWithFile(rootPath);
    } else {
	file.initWithPath(rootPath);
    }

    pathParts.forEach(function(part) {
	    switch (part) {
	    case "..":
		file = file.parent.QueryInterface(Components.interfaces.nsILocalFile);
		break;
	    case ".":
		break;
	    default:
		file.appendRelativePath(part);
		break;
	    }
	});
    
  
    return file;
}

function checkReadable(path, relpaths) {
  var file = buildPath(path, relpaths);
  return file.exists() && file.isReadable();
}

function checkExecutable(path, relpaths) {
  var file = buildPath(path, relpaths);
  return file.exists() && file.isExecutable() ? file : null;
}

function checkWritable(path, relpaths) {
  var file = buildPath(path, relpaths);

  return (file.exists() && file.isWritable()) || (file.parent.exists() && file.parent.isWritable()) ? file : null;
}

function execFile(file, args, blocking) {
  var nsIProcess = Components.interfaces.nsIProcess;

  var process = Components.classes["@mozilla.org/process/util;1"].createInstance(nsIProcess);
  
  process.init(file);

  var pid = process.run(blocking, args, args.length);

  return process;
}

function deleteFile(path, relpaths) {
  if (!GetBoolPref("debug.keepFiles")) {
    var f = checkExists(path, relpaths);

    try {
      if (!f) {
	throw "can not delete, because file does not exist";
      }
      f.remove(false);
    } catch (e) {
      Components.utils.reportError(e + ": " + path); 
    }
  }
}

function YAGI_getXpointerlib() {
    if (typeof this.xpointerlib == "undefined") {
	try {
	    var xptrService = Components.classes["@mozilla.org/xpointer-service;1"].getService(); 
	    this.xpointerlib = xptrService.QueryInterface(Components.interfaces.nsIXPointerService);
	} catch (e) {
	    this.xpointerlib = null;
	}
    }

    return this.xpointerlib;
}

/**
  * get xpointer for current firefox selection
  * depends: xpointerlib
  */
 function YAGI_getXpointerForSelection() {
     var xpointer = "";
     var xptrService = YAGI_getXpointerlib();

     var select = window.content.getSelection();
     var doc = window.content.document;

     if ("" != select) {
	 xpointer = xptrService.createXPointerFromSelection(select, doc);
     }
     
     return xpointer;
 }

/**
  * apply xpointer get xpointer for current firefox selection
  * depends: xpointerlib
  */
function YAGI_applyXpointer(xpointer, doc, wrap) {
    trace("(yagi):" + "applyXpointer(" + xpointer + ")");

     var xptrService = Components.classes["@mozilla.org/xpointer-service;1"].getService(); 
     xptrService = xptrService.QueryInterface(Components.interfaces.nsIXPointerService);
     
     var range;

     try {
	 range = xptrService.parseXPointerToRange(decodeURI(xpointer), doc);
     } catch (e) { // xpointer could not be found in this document
	 trace("(yagi):" + "applyXpointer: " + e);

	 return null;
     }

     if (wrap) {
	 var wrapper_element;
	 
	 if (range.startContainer.parentNode.hasAttribute("xpointer-wrapper")) {
	     trace("(yagi):" + "applyXpointer: already wrapped");
	     wrapper_element = range.startContainer.parentNode;		// already wrapped
	 } else {
	     
	     var span = doc.createElement("span");
	     span.setAttribute("xpointer-wrapper", "yes");
	     span.className = "xpointer_wrapper";

	     xptrService.markElement(span);
	     
	     trace("(yagi):" + "applyXpointer: wrapping");
	     
	     range.surroundContents(span);
	     
	     wrapper_element = span;
	 }
	 
	 return wrapper_element;
     } else {
	 return range;
     }
 }

/**
 * get current or most recent content DOMWindow 
 */
function YAGI_getContentWindow() {
    var win;

    if (typeof window != "undefined" && typeof window.content != "undefined") {
	win = window.content;
    } else {
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	var recentWindow = wm.getMostRecentWindow("navigator:browser");
	if (recentWindow) {
	    win = recentWindow.content;
	}
    }
    return win;
}


/**
 * get current or most recent tabbrowser 
 */
function YAGI_getBrowser() {
    var browser;
    if (typeof getBrowser != "undefined") {
	browser = getBrowser();
    } else {
	
	browser = wm.getMostRecentWindow("navigator:browser").getBrowser();

    }

    return browser;
}

/**
 * load hack hide real page url (e.g. ungly url of page from chrome)
 * Note: page will be loaded synchroneously, so use only for local URIs
 */

function YAGI_loadUri(display_uri, data_uri, browser) {
    var URILOADER = "@mozilla.org/uriloader;1";
    var nsIURILoader = Components.interfaces.nsIURILoader;

    var loader = Components.classes[URILOADER].createInstance(nsIURILoader);
    
    var ios = Components.classes["@mozilla.org/network/io-service;1"]
    .getService(Components.interfaces.nsIIOService);
    
    browser = browser || YAGI_getBrowser();

    var win = YAGI_getContentWindow();

    var channel = ios.newChannel(data_uri, null, null);

    var uri = ios.newURI(display_uri, null, null);

    channel.originalURI = uri;

    loader.openURI(channel, false, browser.webNavigation);
}
   
/**
 * search for existing tab matching given url
 */
function YAGI_getTab(url_pattern) {
    var resultTab;
    var previousTab;

    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
	.getService(Components.interfaces.nsIWindowMediator);
    var browserEnumerator = wm.getEnumerator("navigator:browser");
    

    // Check each browser instance for our URL
    bigloop:
    while (browserEnumerator.hasMoreElements()) {
	var browserInstance = browserEnumerator.getNext().getBrowser();
	
	// Check each tab of this browser instance
	for(var index=0, numTabs = browserInstance.tabContainer.childNodes.length;
	    index < numTabs;
	    index++) {

	    var currentTab = browserInstance.tabContainer.childNodes[index];
	    if (currentTab.linkedBrowser.currentURI.spec.match(url_pattern)) {
		resultTab = currentTab;
		previousTab = browserInstance.selectedTab;
		break bigloop;
	    }
	}
    }
    return [resultTab, previousTab];
}
 
/**
 * open new blank tab, or return existing one matching url pattern.
 * @param url_pattern pattern to match
 * @param backgroundTab do not focus/bring-forward tab
 * @return a pair like array: [browser, previousTab]
 */
function YAGI_openOrReuseTab(url_pattern, backgroundTab) {
    var resultTab;
    var previousTab;

    var [resultTab, previousTab] = YAGI_getTab(url_pattern);


    if (!resultTab) {
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
	    .getService(Components.interfaces.nsIWindowMediator);
	
	function newTab() {
	    var recentWindow = wm.getMostRecentWindow("navigator:browser");
	    
	    if (recentWindow) {
		// Use an existing browser window
		previousTab = recentWindow.getBrowser().selectedTab;
		return recentWindow.getBrowser().addTab("about:blank");
	    }
	}

	resultTab = newTab();
	
	if (!resultTab) { /*
			   * even newTab above failed! maybe no navigator:browser.
			   * open new browser and try again
			   */
	    
	    window.open("about:blank");

	    resultTab = newTab();
	    
	    if (!resultTab) {
		throw Components.Error("can not create or retrive tab");
	    }
	}
    }

    if (backgroundTab != true) {
	var tabbrowser = resultTab.ownerDocument.getElementById("content");
	
	try {
	    tabbrowser.selectedTab = resultTab;
	    tabbrowser.focus();
	} catch (e) { // bug? don't know why above throws exeption when browser in full screen mode
	    trace("(yagiteach): warning: YAGI_openOrReuseTab(): " + e);
	}
    }

    return [resultTab, previousTab];
}


function checkExists(path, relpaths) {
  var file = buildPath(path, relpaths);
  return file.exists() ? file : null;
}

function makeDir(path, parts) {

    var file = buildPath(path, parts);

    var paths = [];
    
    for (var p = file; p != null;) {
	paths.push(p.QueryInterface(Components.interfaces.nsILocalFile));

	try {
	    p = p.parent;
	} catch (e) {
	    p = null;
	}
    }
      
    paths.reverse().forEach(function(p) {
	    if (!p.exists()) {
		p.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0755);
	    }
	});

    return file;
}


function pathToUri(path) {
  var protocol = "file://";

  if (path[0] != '/') { // windows files start with c: or d: etc.
    protocol += '/'; // jre 1.4 throws UnknownHostExcetion with urls like "file://c:/" - need file:///c:/
  }

  return protocol + path;
}

var gTmpFileCounter = 0;

function getProfDir() {
  // get profile directory
  var file = Components.classes["@mozilla.org/file/directory_service;1"]
    .getService(Components.interfaces.nsIProperties)
    .get("ProfD", Components.interfaces.nsIFile);

  return file.path;
}

function getTmpDir() {
  // get profile directory
  var file = Components.classes["@mozilla.org/file/directory_service;1"]
    .getService(Components.interfaces.nsIProperties)
    .get("TmpD", Components.interfaces.nsIFile);

  return file.path;
}


function makeTmpFile(prefix, suffix) {
  const nsILocalFile = Components.interfaces.nsILocalFile;
  const nsIProperties = Components.interfaces.nsIProperties;
  const dirservCID = '@mozilla.org/file/directory_service;1';
  
  var dir = Components.classes[dirservCID].createInstance(nsIProperties).get('TmpD', nsILocalFile);

  
  dir.appendRelativePath(prefix + gTmpFileCounter++ + suffix);

  return dir.path;
}



function execAsync(cmd, args) {
    var file;

    var nsILocalFile = Components.interfaces.nsILocalFile;

    if (cmd instanceof nsILocalFile) {
	file = cmd;
    } else {
	file = Components.classes["@mozilla.org/file/local;1"].createInstance(nsILocalFile);

	file.initWithPath(cmd);
    }

  var nsIProcess = Components.interfaces.nsIProcess;

  var process = Components.classes["@mozilla.org/process/util;1"].createInstance(nsIProcess);
  
  process.init(file);
  
  var runnable = {process: process, args: args, run: function() {
      this.process.run(true, this.args, this.args.length);
    }
  };

  var th = makeThread(runnable); // @TODO this leaves a dangling thread which needs shutting down on FF3 

  return process;
}

function makeThread(runnable) {
    
    const nsIThread = Components.interfaces.nsIThread;
    const nsIThreadManager = Components.interfaces.nsIThreadManager;

    var th;

    if (nsIThreadManager) {
	th = Components.classes["@mozilla.org/thread-manager;1"].getService().newThread(0);
	th.dispatch(runnable, nsIThread.DISPATCH_NORMAL);
    } else {
	th = Components.classes["@mozilla.org/thread;1"].createInstance(nsIThread);
	th.init(runnable, 0, 
		nsIThread.PRIORITY_NORMAL,
		nsIThread.SCOPE_GLOBAL,
		nsIThread.STATE_UNJOINABLE);
    }

    return th;
}


// search environment variable PATH for an executable
function searchPath(name) {

  var env = Components.classes["@mozilla.org/process/environment;1"].
    createInstance(Components.interfaces.nsIEnvironment);

  var path = env.get("PATH");

  var wpath = path.split(';');

  if (wpath.length > 1) {
    path = wpath;
  } else {
    path = path.split(':');
  }

  for (var i in path) {
    
    for (var suffix in {"":1, ".exe":1}) {
      try {
	var prog = checkExecutable(path[i], [name + suffix]);

	if (prog) {
	  return prog;
	}
      } catch (e) {}
    }
  }

  return null;
}

function getOS() {
  var platform = null;

  if (navigator.platform.match(/linux.*/i)) {
    platform = "linux";
  } else if (navigator.platform.match(/win32.*/i)) {
    platform = "win32";
  } else {
    platform = "unknonw";
  }

  return platform;
}

  

function YAGI_assert(test, message) {
  if (!test) {
    //throw "assert error";
    trace("(yagi): assertion error: " + message);
  }
}

/**
 * loads uri data 
 * @return uri data as string
 * TODO: rename to YAGI_loadUri()
 */
function loadFile(url) {
    var ios = Components.classes["@mozilla.org/network/io-service;1"]
	.getService(Components.interfaces.nsIIOService);

    var channel = ios.newChannel(url, null, null);

    return readStream(channel.open());
}

/**
 * load external javascript files: e.g. loadScript("chrome://yagitalk/contents/scripts/utilitites.js")
 */
function loadScript(url, scope) {
  var sl = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].
    createInstance(Components.interfaces.mozIJSSubScriptLoader);

  sl.loadSubScript(url, scope);
}

function LocationListener() { // implements 

    // private vars
    var listeners = {};
    var progressListener; 
    var inited = false;

    // public methods
    this.add = function(fun) {
	listeners[fun] = fun;
    }

    this.addAll = function(funCollections) {
	for (var fun in funCollections) {
	    this.add(funCollections[fun]);
	}
    }

    this.remove = function(fun) {
	delete listeners[fun];
    }

    this.removeAll = function(funCollections) {
	for (var fun in funCollections) {
	    this.remove(funCollections[fun]);
	}
    }
    
    this.init = function() {
	if (!inited) {
	    getBrowser().addProgressListener(progressListener, Components.interfaces.nsIWebProgress.NOTIFY_ALL);
	    inited = true;
	}
    }
	
    // implementation

    progressListener = {
	onLocationChange : function(aWebProgress, aRequest, aLocation) {
	    for (var fun in listeners) {
		try {
		    if (listeners[fun](aLocation)) {
			delete listeners[fun];
		    }
		} catch (e) {
		    dump("(yagi):" + "LocationListener:" + e + "(on " + fun + ")");
		}
	    }
	},
	onStateChange: function(url, aStateFlags) {
	},
	onProgressChange : function(aWebProgress, aRequest,
				    aCurSelfProgress, aMaxSelfProgress,
				    aCurTotalProgress, aMaxTotalProgress)  {
	},
	onStatusChange : function(aWebProgress, aRequest, aStatus, aMessage)  {
	},
	onSecurityChange: function(aWebProgress, aRequest, aState)  {
	},
	onLinkIconAvailable : function(aWebProgress){
	}
    };
}

function YAGI_getPrefBranch(branch) {
    const CID = "@mozilla.org/preferences-service;1";
    const nsIPrefBranch2 = Components.interfaces.nsIPrefBranch2;
    const nsIPrefService = Components.interfaces.nsIPrefService;
    
    var prefs = Components.classes[CID].getService(nsIPrefService);

    prefs = prefs.getBranch(branch || "");

    return prefs.QueryInterface(nsIPrefBranch2);
}

function YAGI_setPref(branch, pref, val, create) {
    trace("(yagi): YAGI_setPref: info: setting (create=" + (create ? "true" : "false") + ") : " + branch + pref + "=" + val);

    const nsIPrefBranch = Components.interfaces.nsIPrefBranch;

    var prefs = YAGI_getPrefBranch(branch);
    var type = prefs.getPrefType(pref);

    if (type == nsIPrefBranch.PREF_INVALID) {
	var jstype = (typeof val);

	if (create) {
	    switch (jstype) {
	    case "boolean":
		type = nsIPrefBranch.PREF_BOOL;
		break;
	    case "string":
		type = nsIPrefBranch.PREF_STRING;
		break;
	    case "number":
		type = nsIPrefBranch.PREF_INT;
		break;
	    default:
		trace("(yagi): YAGI_setPref: error: preference type " + type + " not supported by firefox");
		throw Error("preference type " + type + " not supported by firefox");
	    }
	} else {
	    trace("(yagi): YAGI_setPref: error: no such pref: " + branch + pref);
	    throw Error("no such pref: " + branch + pref);
	}
    }

    switch (type) {
    case nsIPrefBranch.PREF_STRING:
	prefs.setCharPref(pref, val);
	break;
    case nsIPrefBranch.PREF_INT:
	prefs.setIntPref(pref, val);
	break;
    case nsIPrefBranch.PREF_BOOL:
	prefs.setBoolPref(pref, val);
	break;
    default:
	throw Error("YAGI_getPref: HDIGH!");
    }
}

function YAGI_getPref(branch, pref) {
    const nsIPrefBranch = Components.interfaces.nsIPrefBranch;

    var prefs = YAGI_getPrefBranch(branch);

    switch (prefs.getPrefType(pref)) {
    case nsIPrefBranch.PREF_INVALID:
	throw Error("no such pref: " + branch + pref);
	break;
    case nsIPrefBranch.PREF_STRING:
	return prefs.getCharPref(pref);
    case nsIPrefBranch.PREF_INT:
	return prefs.getIntPref(pref);
    case nsIPrefBranch.PREF_BOOL:
	return prefs.getBoolPref(pref);
    default:
	throw Error("YAGI_getPref: HDIGH!");
    }
}

function YAGI_linkPref(branch, pref, handler) {
    var prefs = YAGI_getPrefBranch(branch);

    var obs = {
	observe: function(subject , topic , data ) {
	    try {
		handler(pref, YAGI_getPref(branch, pref));
	    } catch (e) {
		var func = trace || dump;

		dump("(yagi):" + "YAGI_linkPref: error handling " + branch + pref + ". Removing preference observer");
		prefs.removeObserver(pref, this);
	    }
	}
    };

    prefs.addObserver(pref, obs, false);    

    handler(pref, YAGI_getPref(branch, pref));

    return obs;
}

function YAGI_browserHasFocus() {
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"] .getService(Components.interfaces.nsIWindowMediator); 
    var browserWindow = wm.getMostRecentWindow("navigator:browser");
    return this == browserWindow;
}

function YAGI_escape(str) {
    
    return str.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/\"/g, '&quot;');
}

/**
 * asynchroneously fetch data using XMLHttpRequest.
 * @param url the url of resource to fetch (type string)
 * @param callback a callback object which must define functions onerror(e) and onfinish(data). 
 * @return  depending on either callback.xml is set or not, responseXML or responseText are fed to callback.onfinish. Uppon an error, the exception/error code is passed to callback.onerror
 */
function YAGI_fetchData(url, callback, sync) {
    var  xhr = new XMLHttpRequest();

    xhr.onload = function(e) {
	callback.onfinish(callback.xml ? this.responseXML : this.responseText);
    }

    xhr.onerror = function(e) {
	callback.onerror(this.statusText);
    }

    xhr.open('GET', url, !sync);

    try {
	xhr.send(null);
    } catch (e) { // file uri
	callback.onerror(e);
    }
}


function YAGI_getXMLDocument(url, callback) {
  var xmlHttpRequest = new XMLHttpRequest();
  
  xmlHttpRequest.open("GET", url, callback ? true : false);

  if (callback) {
      xmlHttpRequest.onload = callback.onload;
      
      if (callback.onerror) {
	  xmlHttpRequest.onerror = callback.onerror;
      }
  }

  xmlHttpRequest.send(null);

  return xmlHttpRequest.responseXML;
}

function YAGI_getXMLFragment(xml, xsl, parameters) {
    return YAGI_transformXML(xml, xsl, true, parameters);
}


function transformXMLDocument(xml, xsl, parameters) {
    return YAGI_transformXML(xml, xsl, false, parameters);
}


function YAGI_transformXML(xml, xsl, toFragment, parameters) {
 var transformer = new XSLTProcessor();
 var i;
 
 transformer.importStylesheet(xsl);
 
 if( parameters ) {
  for( i=0 ; i<parameters.length ; i++){
   transformer.setParameter(
       null,
       parameters[i][0],
       getNonNullString(parameters[i][1])
   );
  }
 }
  
 return toFragment ? transformer.transformToFragment(xml, document) : transformer.transformToDocument(xml);
}

function YAGI_generateUUID() {	
    var uuidGenerator = 
	Components.classes["@mozilla.org/uuid-generator;1"]
	.getService(Components.interfaces.nsIUUIDGenerator);
    var uuid = uuidGenerator.generateUUID();
    var uuidString = uuid.toString();

    return uuidString;
}

function xpath(aXpath, scope)
{
  var foundNodes = new Array();
  var res;
  var nsResolver = function(prefix) {
      var ns = {    'lp' : 'http://www.yagitalk.org/mozext/link.preference.to.xul.element'  };
      return ns[prefix] || null;
  };

  var result = document.evaluate(aXpath, scope || document, nsResolver, 0, null);

  while ((res = result.iterateNext())) {
      foundNodes.push(res);
  }
  return foundNodes;
}
	
var gYagiLocationListener = new LocationListener();
