var gAborted = false;
var gDumped = null;
var gDump2Zip = null;

function initWizard() {
  initPrefWin();
}

var gProgress = {
  wizard: null,
  status: null,
  process: null,
  meter: null,
  progress: function() {
    if (this.process.exitValue != -1) {
      this.meter.setAttribute("hidden", "true");
      this.wizard.canAdvance = true;
      this.wizard.canRewind = true;

      if (!gAborted && this.process.exitValue != 0) {
	  alert("Error during Wikipedia dump processing. Make sure dump file is not corrupt and that you have enough disk space.");
      }

      this.status.innerHTML = (0 == this.process.exitValue ? "Done." : 
			       (gAborted ? "Aborted." : "Error."));
    } else {
      setTimeout("gProgress.progress()", 1000);
    }
  },
  abort: function() {
    if (null != this.process) {
      this.process.kill();
    }
  }
};

function zipdump() {
  setPrefs();

  var wizard = document.getElementById("zipdumpWizard");
  wizard.canRewind = false;
  wizard.canAdvance = false;

  var dump = document.getElementById("dump.path").value;
  var outpath = document.getElementById("zip.path").value;

  makeDir(outpath);
    

  { // set dump properties
    var skipTalk = document.getElementById("zip.skipTalk");
    var skipUser = document.getElementById("zip.skipUser");
    var skipImage = document.getElementById("zip.skipImage");
    var compressionLevel = document.getElementById("zip.compression");

    var extPath = getExtensionPath("zipedia", true);

    var zipdump = null;

    var linuxpath = ["chrome", "content", "zipedia", "etc", "zipediadump"];
    var win32path = ["chrome", "content", "zipedia", "etc", "zipediadump.exe"];

    zipdump = checkExists(extPath, win32path) || checkExists(extPath, linuxpath);

    var args = ["--sqlidx"];

    if (skipTalk.value) {
      args.push("--notalk");
    }

    if (skipUser.value) {
      args.push("--nouser");
    }

    if (skipImage.value) {
      args.push("--noimage");
    }

    
    var compression;

    switch (compressionLevel.value) {
    case "best":
      args.push("--best");
      break;
    case "speed":
      args.push("--fast");
      break;
    case "undefined":
    default:
      break;
    }

    args.push(dump);

    args.push(outpath);

    try {
      { // remove old stamp - if exists
	var stamp = checkExists(outpath, [".done"]);
	
	if (stamp) {
	  stamp.remove(false);
	}
      }

      gProgress.process = execAsync(zipdump.path, args);

      gProgress.wizard = wizard;
      gProgress.status = document.getElementById("ETA");
      gProgress.meter = document.getElementById("pwmeter");
      gProgress.meter.setAttribute("hidden", "false");
      gProgress.status.innerHTML = "Running..";
      gProgress.progress();

    } catch (e) {
      alert(e);
    }
  }
}

function abort() {
  if (!gAborted) {
    gAborted = true;

    gProgress.abort();
  }
}

function onCancel() {
  abort();

  return true;
}

function onFinish() {
  var dumpPath = window.arguments[0];

  dumpPath.value = document.getElementById("zip.path").value;
}

function onDumpPathsPageAdvanced() {
  var dumpPath = document.getElementById("dump.path").value;
  var zipPath = document.getElementById("zip.path").value;

  var err = null;

  do {
    if (!dumpPath) {
      err = "you must specify the location of the wikipedia dump file (*.xml.bz2)";
      break;
    }

    if (!checkReadable(dumpPath)) {
      err = dumpPath + ": file does not exist or is not readable";
      break;
    }

    if (!zipPath) {
	document.getElementById("zip.path").value = buildPath(getProfDir(), ["zipedia"]).path;
    }

    if (checkExists(zipPath, ["zipedia.sq"])) {
      if (!ConfirmWithTitle("Files Exist", zipPath + ": directory seems to already contain previous dump - overwrite?", "Yes", "No")) {
	return false;
      }
    }

    if (!checkWritable(zipPath)) {
      err = zipPath + ": parent directory does not exist or not writable";
      break;
    }
  } while (false);
    

  if (err) {
    alert(err);
  }

  return !err;
}
