var tracingEnabled = false;

var gWikiData = null;

var WikiDataModule = {
  myCID : Components.ID("{03db707a-d834-45bb-bba2-20aea408468f}"),
  myProgID : "@nargila.org/wiki-data/java;1",
  
  registerSelf : function(compMgr, fileSpec, location, type) {
    compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
    compMgr.registerFactoryLocation(
				    this.myCID,
				    "Zipedia Wiki Data",
				    this.myProgID,
				    fileSpec,
				    location,
				    type
				    );
  },
  
  unregisterSelf : function(compMgr, fileSpec, location) {
    compMgr = compMgr.QueryInterface(nsIComponentRegistrar);
    compMgr.unregisterFactoryLocation(this.myCID, fileSpec);
  },
  
  getClassObject : function(compMgr, cid, iid) {
    if (!cid.equals(this.myCID)) {
      throw Components.results.NS_ERROR_NO_INTERFACE;
    }
    if (!iid.equals(Components.interfaces.nsIFactory)) {
      throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
    }
    return this.myFactory;
  },

  canUnload : function(compMgr) {
    return true;
  },

  myFactory : {
    createInstance : function(outer, iid) {
      if (outer != null) {
	throw Components.results.NS_ERROR_NO_AGGREGATION;
      }

      if (!gWikiData) {
	//var synchQueue = makeEventQueue();
	//var wikiData = new WikiData(synchQueue);
	var wikiData = new WikiData(null);

	gWikiData = wikiData;
	//gWikiData = makeEventQueueProxy(synchQueue, wikiData, Components.interfaces.zpwkIWikiData);
	//gWikiData.load();
      }


      var dummy = {
	QueryInterface: function(iid) {
	  if (iid.equals(Components.interfaces.zpwkIWikiDataJava) || 
	      iid.equals(Components.interfaces.zpwkIWikiData) ||
	      !iid.equals(Components.interfaces.nsISupports)) {
	      return this;
	  }

	  throw Components.results.NS_ERROR_NO_INTERFACE;
	}
      };

      return gWikiData;

      //return dummy;
    }
  }
}


function NSGetModule(compMgr, fileSpec) {
    return WikiDataModule;
}


/*----------------------------------------------------------------------
 * The ChromeExtension Handler
 *----------------------------------------------------------------------
 */


function EntryIterator(list) {
    var iterator = list.iterator();


    this.hasMore = function() {
	return iterator.hasNext();
    }

    this.getNext = function() {
	return "" + iterator.next();
    }
}


function WikiData() {

    var javaObj;


    this.QueryInterface = QueryInterface;

    this.init = init;

    this.load = function() { /* noop */}
    this.close = function() { /* noop */}

    this.getArticle = getArticle;

    this.getNamespaces = getNamespaces;

    this.format = format;

    this.findArticle = findArticle;

    //////////////////// implementation ////////////////////////
    
    function QueryInterface(iid) {

	if (iid.equals(Components.interfaces.zpwkIWikiDataJava) || 
	    iid.equals(Components.interfaces.zpwkIWikiData) ||
	    iid.equals(Components.interfaces.nsISupports)) {
	    return this;
	}

	throw Components.results.NS_ERROR_NO_INTERFACE;
    }

    function init(javaWrapper) {
	
	if (!javaObj) {
	    javaObj = getJavaObject(javaWrapper);
	}
    }

    function getArticle(namespace, title, raw) {

	var data = javaObj.getArticle(namespace, title, raw);

	return data; // Utf8.encode(data);
    }

    function format(txt, url) {
	switch (YAGI_getPref("zipedia.backend.", "converter")) {
	case "bliki":
	    return javaObj.format(txt);
	case "js":
	    return new WikiConvert().convert(txt, url);
	default:
	    throw "HDIGH!";
	}
    }

    function getNamespaces() {
	return new EntryIterator(javaObj.getNamespaces());
    }

    function findArticle(namespace, aPattern) {
	return new EntryIterator(javaObj.findArticle(namespace, aPattern));
    }

    ///////////////////////////// private ///////////////////////

    function getJavaObject(javaWrapper) {
           
	var java = javaWrapper.wrappedJSObject;

	var path = getExtensionPath("zipedia", true);

	path = fixPath(path); // windows,unix path compatibility
    
	var dirpath = YAGI_getPref("zipedia.", "zip.path") || buildPath(path, ["zipdata"]).path;
    
	var classLoader = getClassLoader(javaWrapper);
    
	var obj = classLoader.newInstance("org.nargila.zipedia.Zipedia");

	obj.init(dirpath);

	return obj;

    }


    function getClassLoader(javaWrapper) {

	var java = javaWrapper.wrappedJSObject;

	var javaPathBase = getExtensionPath("zipedia") + "components/lib";

	var bootStrapPath = javaPathBase + "/classes/";

	var classLoader = new ClassLoader(java, bootStrapPath);

	//classLoader.addURL(javaPathBase + "/sqlitejdbc.jar");
      
	classLoader.addURL(javaPathBase + "/h2.jar");
      
	classLoader.addURL(javaPathBase + "/bliki.jar");
      
	return classLoader;
    }
}







/**
*  
*  UTF-8 data encode / decode
*  http://www.webtoolkit.info/
*
**/

var Utf8 = {

    // public method for url encoding
    encode : function (string) {
        string = string.replace(/\r\n/g,"\n");
        var utftext = "";

        for (var n = 0; n < string.length; n++) {

            var c = string.charCodeAt(n);

            if (c < 128) {
                utftext += String.fromCharCode(c);
            }
            else if((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }

        }

        return utftext;
    },

    // public method for url decoding
    decode : function (utftext) {
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;

        while ( i < utftext.length ) {

            c = utftext.charCodeAt(i);

            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            }
            else if((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i+1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            }
            else {
                c2 = utftext.charCodeAt(i+1);
                c3 = utftext.charCodeAt(i+2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }

        }

        return string;
    }

}

/**
 * load external javascript files: e.g. loadScript("chrome://yagitalk/contents/scripts/utilitites.js")
 */
function loadScript(url) {
  var sl = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].
    createInstance(Components.interfaces.mozIJSSubScriptLoader);

  sl.loadSubScript(url);
}

loadScript("chrome://zipedia/content/scripts/utilities.js");
loadScript("chrome://zipedia/content/wiki/wikiconvert.js");
loadScript("chrome://zipedia/content/scripts/classloader.js");

