var tracingEnabled = false;

var WikiDataModule = {
  myCID : Components.ID("{ea792f7e-ac9b-4285-b004-8073dd56ef5b}"),
  myProgID : "@nargila.org/wiki-data/sqlite;1",
  
  registerSelf : function(compMgr, fileSpec, location, type) {
    compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
    compMgr.registerFactoryLocation(
				    this.myCID,
				    "Zipedia Wiki Data",
				    this.myProgID,
				    fileSpec,
				    location,
				    type
				    );
  },
  
  unregisterSelf : function(compMgr, fileSpec, location) {
    compMgr = compMgr.QueryInterface(nsIComponentRegistrar);
    compMgr.unregisterFactoryLocation(this.myCID, fileSpec);
  },
  
  getClassObject : function(compMgr, cid, iid) {
    if (!cid.equals(this.myCID)) {
      throw Components.results.NS_ERROR_NO_INTERFACE;
    }
    if (!iid.equals(Components.interfaces.nsIFactory)) {
      throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
    }
    return this.myFactory;
  },

  canUnload : function(compMgr) {
    return true;
  },

  myFactory : {
	createInstance : function(outer, iid) {
	    if (outer != null) {
		throw Components.results.NS_ERROR_NO_AGGREGATION;
	    }

	    trace("Zipedia: createInstance() >>");

	    return new WikiData();

	    trace("Zipedia: createInstance() <<");
	}
  }
}


function NSGetModule(compMgr, fileSpec) {
    return WikiDataModule;
}


/*----------------------------------------------------------------------
 * The ChromeExtension Handler
 *----------------------------------------------------------------------
 */


function EntryIterator(list) {
    var iterator = list.iterator();


    this.hasMore = function() {
	return iterator.hasNext();
    }

    this.getNext = function() {
	return "" + iterator.next();
    }
}


function WikiData() {
   
    trace("Zipedia: WikiData() >>");

    this.QueryInterface = QueryInterface;

    this.load = load;

    this.close = close;

    this.getArticle = getArticle;

    this.getNamespaces = getNamespaces;

    this.format = format;

    this.findArticle = findArticle;

    //////////////////// implementation ////////////////////////
    
    trace("Zipedia: WikiData() new WikiDataSqlite() >>");

    var wikiData = new WikiDataSqlite();

    trace("Zipedia: WikiData() new WikiDataSqlite() <<");

//     trace("Zipedia: WikiData() load() >>");
//     wikiData.load();
//     trace("Zipedia: WikiData() load() <<");

    function QueryInterface(iid) {

	if (iid.equals(Components.interfaces.zpwkIWikiDataSqlite) || 
	    iid.equals(Components.interfaces.zpwkIWikiData) ||
	    iid.equals(Components.interfaces.nsISupports)) {
	    return this;
	}

	throw Components.results.NS_ERROR_NO_INTERFACE;
    }

    function load() {
	wikiData.load();
    }

    function close() {
	wikiData.close();
    }

    function getArticle(namespace, title, raw) {

	var data = wikiData.getEntry(namespace + ":" + title);

	return data; // Utf8.encode(data);
    }

    function format(txt, url) {

	return new WikiConvert().convert(txt, url);
    }

    function getNamespaces() {
	return wikiData.getNamespaces();
    }

    function findArticle(namespace, aPattern) {
	return wikiData.findEntries(namespace + ":" + aPattern);
    }

    trace("Zipedia: WikiData() <<");

}




/**
 * load external javascript files: e.g. loadScript("chrome://yagitalk/contents/scripts/utilitites.js")
 */
function loadScript(url) {
  var sl = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].
    createInstance(Components.interfaces.mozIJSSubScriptLoader);

  sl.loadSubScript(url);
}

loadScript("chrome://zipedia/content/scripts/utilities.js");
loadScript("chrome://zipedia/content/wiki/wikiconvert.js");
loadScript("chrome://zipedia/content/wiki/wikidata.js");

